#include <iostream>
using namespace std;

int gcd(int a, int b)
{
  if (a < 0) a = -a;
  if (b < 0) b = -b;
  while (b != 0) {
    int tmp = a%b;
    a = b;
    b = tmp;
  }
  return a;
}

class Extreme {
  static const int SPEC = -1;
  int Min, Max, First;
public:
  Extreme() : Min(SPEC), Max(SPEC), First(SPEC) {};
  void candidate(int c) {
    if (First == SPEC) {
      First = Min = Max = c;
    } else {
      if (c < Min) Min = c;
      else if (c > Max) Max = c;
    } 
  }
  int min() {return Min;}
  int max() {return Max;}
  int first() {return First;}
};

int main() {
  int k;
  cin >> k;
  while (k--) {
    int a, b;
    Extreme A, B;
    cin >> a >> b;
    int MinStep = 0;
    while (a--) {
      int step;
      cin >> step;
      A.candidate(step);
      MinStep = gcd(MinStep, step - A.first());
    }
    while (b--) {
      int step;
      cin >> step;
      B.candidate(step);
      MinStep = gcd(MinStep, step - B.first());
    }
    MinStep = gcd(MinStep, A.first() - B.first());
    bool answer;
    answer = A.max() > B.min() && B.max() > A.min()
             && (MinStep == 1 || MinStep == 2 && A.first() % 2 == 1);
    cout << (answer ? "YES" : "NO") << '\n';
  }
}
