#include <iostream>
#include <set>
#include <vector>
#include <assert.h>

using namespace std;

typedef long long LL;

#define MAXM (1<<20)
#define INF 1500000000
int N, M, p2 = 1, len[MAXM], bottom[MAXM], top[MAXM], cnt[MAXM];

#define LEFT(x) (((x)<<1)+1)
#define RIGHT(x) (((x)<<1)+2)
#define PARENT(x) (((x)-1)>>1)
#define WATCH(x) if (!cnt[x])len[x]=LEFT(x)<M?len[LEFT(x)]+len[RIGHT(x)]:0;

// add = true means insert; add = false means delete
void tree_update(int u, int y1, int y2, bool add) {
  if (y1<=bottom[u] && y2>=top[u]) {
    if (add)
      ++cnt[u], len[u] = top[u] - bottom[u];
    else {
      --cnt[u];
      WATCH(u)
    }
  } else {
    if (y1 < top[LEFT(u)])
      tree_update(LEFT(u), y1, y2, add);
    if (y2 > bottom[RIGHT(u)])
      tree_update(RIGHT(u), y1, y2, add);
    WATCH(u)
  }
}

int main() {
  LL ret = 0, cur = -INT_MAX;
  set<int> ys;
  cin >> N;
  vector< pair<int, pair< pair<int, int>, int > > > v;
  for (int i = 0; i < N; ++i) {
    int x1, x2, y1, y2;
    cin >> x1 >> x2 >> y1 >> y2;    
    ys.insert(y1), ys.insert(y2);
    v.push_back(make_pair(x1, make_pair(make_pair(y1, y2), 1)));
    v.push_back(make_pair(x2, make_pair(make_pair(y1, y2), 0)));
  }
  sort(v.begin(), v.end());
  while (p2 < ys.size())
    p2 <<= 1;
  M = 2*p2 - 1;
  memset(cnt, 0, sizeof(cnt));
  memset(len, 0, sizeof(len));
  for (int i = 0; i < M; ++i)
    bottom[i] = INT_MAX, top[i] = -INT_MAX;
  int at = p2 - 1;
  set<int>::iterator iter = ys.begin();
  for (++iter; iter != ys.end(); ++iter)
    bottom[at] = *(--iter), top[at] = *(++iter), ++at;
  while (at < M)
    bottom[at] = top[at] = INF, ++at;
  for (int i = M - 1; i > 0; --i) {
    bottom[PARENT(i)] = min(bottom[PARENT(i)], bottom[i]);
    top[PARENT(i)] = max(top[PARENT(i)], top[i]);
  }
  for (int i = 0; i < v.size(); ++i) {
    ret += len[0] * (v[i].first - cur);   
    cur = v[i].first;
    tree_update(0, v[i].second.first.first, v[i].second.first.second,
		v[i].second.second);
  }
  cout << ret << endl;
}
