#include <fstream>
#include <iostream>
#include <vector>
#include <cmath>
#include <functional>
#include <algorithm>

using namespace std;

#define EPS 1e-8

int M, N;
vector<vector<double> > mat;
vector<int> sol;

void input()
{
  cin >> M >> N;
  mat.resize(N);
  double a;
  for (int i = 0; i < M; i++)
    for (int j = 0; j < N; j++)
      {
	cin >> a;
	mat[j].push_back(a);
      }
}

bool eq_to_zero(double a)
{
  if (fabs(a) < EPS)
    return true;
  else
    return false;
}

template<typename T>
struct add_scaled : public binary_function<T,T,T>
{
  add_scaled(double coef) : k(coef) {}
  T operator()(T a, T b) const
  {
    return a + k * b;
  }
  const double k;
};

void solve()
{
  int lead = 0;
  int r = 0;
  bool stop = false;
  while ((r < N) && (!stop))
    {
      if (lead >= M)
	stop = true;
      else
	{
	  int i = r;
	  while ((!stop) && (eq_to_zero(mat[i][lead])))
	    {
	      i++;
	      if (i == N)
		{
		  i = r;
		  lead++;
		  if (lead == M)
		    stop = true;
		}
	    }
	  if (!stop)
	    {
	      swap(mat[i], mat[r]);
	      for (i = 0; i < N; i++)
		if ((i != r) && (!eq_to_zero(mat[i][lead])))
		  transform(mat[i].begin(), mat[i].end(), mat[r].begin(), mat[i].begin(), add_scaled<double>(-mat[i][lead]/mat[r][lead]));
	    }
	}
      lead++;
      r++;
    }
  
  for (r = 0; r < N; r++)
    {
      int c = 0, i = -1;
      bool two = false;
      while ((c < M) && (!two))
	{
	  if (!eq_to_zero(mat[r][c]))
	    if (i == -1)
	      i = c;
	    else
	      two = true;
	  c++;
	}
      if ((i != -1) && (!two))
	sol.push_back(i + 1);
    }
}

void output()
{
  cout << sol.size() << endl;
  for (int i = 0; i < sol.size(); i++)
    cout << sol[i] << endl;
}

int main()
{
  input();
  solve();
  output();
  return 0;
}
